<template>
    <BudgetNavigation/>
    <div class="row">
        <div class="col-12">
            <h4>Бюджеты</h4>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <BudgetDetailsAdd
                :municipalityId="municipalityId"
                @budgetAdded="detailsListUpdateRequired = true"/>
            <BudgetDetailsTable
                :detailsList="detailsList"/>
        </div>
    </div>
</template>

<script>
    import BudgetNavigation from '../BudgetNavigation.vue';
    import BudgetDetailsAdd from './BudgetDetailsAdd'
    import BudgetDetailsTable from './BudgetDetailsTable'
    import { BudgetDetailsService } from '../../services/budgetDetailsService'
    import { defaultHandleErrorFunction } from '@/services/http-common'

    export default {
        name: 'BudgetDetailsList',
        components: {
            BudgetNavigation,
            BudgetDetailsAdd,
            BudgetDetailsTable
        },
        props: {
            municipalityId: Number
        },
        data() {
            return {
                detailsList: [],
                detailsListUpdateRequired: true
            }
        },
        methods: {
            checkUpdateRequired(){
                if (this.detailsListUpdateRequired) {
                    this.updateDetailsList();
                    this.detailsListUpdateRequired = false;
                }
            },
            updateDetailsList() {
                budgetDetailsService
                    .get(this.municipalityId)
                    .then(response => this.detailsList = response
                        .data
                        .sort((a, b) => a.date - b.date))
                    .catch(defaultHandleErrorFunction);
            }
        },
        watch: {
            detailsListUpdateRequired: function (val) {
                this.checkUpdateRequired();
            },
        },
        created() {
            this.checkUpdateRequired();
        }
    };

    const budgetDetailsService = new BudgetDetailsService();
</script>
